Index: /gs3-installations/intermuse/trunk/interfaces/intermuse/interfaceConfig.xml
===================================================================
--- /gs3-installations/intermuse/trunk/interfaces/intermuse/interfaceConfig.xml	(revision 37057)
+++ /gs3-installations/intermuse/trunk/interfaces/intermuse/interfaceConfig.xml	(revision 37057)
@@ -0,0 +1,247 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<interfaceConfig baseInterface="default">
+	<actionList>
+		<action class="PageAction" name="p">
+			<subaction name="home" xslt="pages/home.xsl"/>
+			<subaction name="about" xslt="pages/about.xsl"/>
+			<subaction name="debug" xslt="pages/debuginfo.xsl"/>
+			<subaction name="pref" xslt="pages/pref.xsl"/>
+			<subaction name="help" xslt="pages/help.xsl"/>
+			<subaction name="login" xslt="pages/login.xsl"/>
+			<subaction name="verify" xslt="pages/verify.xsl"/>
+			<subaction name="error" xslt="pages/error.xsl"/>
+			<subaction name="gli4gs3" xslt="gli4gs3.xsl"/>
+			<subaction name="nav" xslt="nav.xsl"/>
+			<!-- used for the collection header frame -->
+			<subaction name="html" xslt="pages/html.xsl"/>
+			<!-- use to put an external page into a frame with a collection header-->
+		</action>
+
+		<action class="RSSAction" name="rss" xslt="pages/rss.xsl"/> 
+		<action class="QueryAction" name="q" xslt="pages/query.xsl"/>
+		<action class="GS2BrowseAction" name="b" xslt="pages/classifier.xsl"/>
+		<action class="DocumentAction" name="d" xslt="pages/document.xsl">
+		  <subaction name="print" xslt="pages/document-print.xsl"/>
+		</action>
+
+		<action class="AppletAction" name="a" xslt="pages/applet.xsl"/>
+		<action class="XMLDocumentAction" name="xd">
+			<subaction name="toc" xslt="pages/document-toc.xsl"/>
+			<subaction name="text" xslt="pages/document-content.xsl"/>
+		</action>
+		<action class="ProcessAction" name="pr" xslt="process.xsl"/>
+		<action class="SystemAction" name="s" xslt="pages/system.xsl"/>
+
+		<action class="FormatAction" name="f"/>
+		<!-- xslt='formatString.xsl'/> -->
+
+		<action class="GeneralAction" name="g">
+			<subaction name="authen" xslt="pages/authen.xsl"/>
+			<subaction name="fav" xslt="pages/favourites.xsl"/>
+			<subaction name="documentbasket" xslt="pages/documentbasket.xsl"/>
+		</action>
+
+		<action class="DepositorAction" name="de" xslt="pages/depositor_home.xsl">
+			<subaction name="getwizard" xslt="depositor/compiledDepositor.xsl"/>
+		</action>
+	</actionList>
+	<optionList>
+		<!-- Uncomment and update this option if you want to introduce custom CSS to this interface. -->
+		<!-- <option name="cssTheme" value="interfaces/default/style/themes/main/jquery-ui.theme.css"/> -->
+
+		<option name="highlightQueryTerms" value="true"/>
+	</optionList>
+	<languageList>
+		<language name="en">
+			<displayItem name="name">English</displayItem>
+		</language>
+		<language name="fr">
+			<displayItem name="name">FranÃ§ais</displayItem>
+		</language>
+		<language name="es">
+			<displayItem name="name">EspaÃ±ol</displayItem>
+		</language>
+		<language name="am">
+		  <displayItem name="name">Amharic</displayItem>
+		</language>
+		<language name="ar">
+			<displayItem name="name">Arabic</displayItem>
+		</language>
+		<language name="bg">
+			<displayItem name="name">Bulgarian</displayItem>
+		</language>
+		<language name="bn">
+			<displayItem name="name">àŠ¬àŠŸàŠàŠ²àŠŸ (Bengali)</displayItem>
+		</language>
+		<language name="ca">
+			<displayItem name="name">CatalÃ  (Catalan)</displayItem>
+		</language>
+		<language name="cs">
+			<displayItem name="name">Äesky (Czech)</displayItem>
+		</language>
+		<language name="de">
+			<displayItem name="name">Deutsch (German)</displayItem>
+		</language>
+		<language name="dv">
+		  <displayItem name="name">Dhivehi</displayItem>
+		</language>
+
+		<language name="el">
+			<displayItem name="name">ÎÎ»Î»Î·ÎœÎ¹ÎºÎ¬ (Greek)</displayItem>
+		</language>
+		<language name="fa">
+			<displayItem name="name">Farsi</displayItem>
+		</language>
+		<language name="fi">
+			<displayItem name="name">Finnish</displayItem>
+		</language>
+		<language name="gd">
+			<displayItem name="name">Gaelic (Scottish)</displayItem>
+		</language>
+		<language name="gl">
+			<displayItem name="name">Galician</displayItem>
+		</language>
+		<language name="gu">
+		  <displayItem name="name">Gujarati</displayItem>
+		</language>
+
+		<language name="he">
+			<displayItem name="name">Hebrew</displayItem>
+		</language>
+		<language name="hi">
+			<displayItem name="name">Hindi</displayItem>
+		</language>
+		<language name="hr">
+		  <displayItem name="name">Croatian</displayItem>
+		</language>
+
+		<language name="hu">
+			<displayItem name="name">Hungarian</displayItem>
+		</language>
+		<language name="hy">
+			<displayItem name="name">Armenian</displayItem>
+		</language>
+		<language name="id">
+			<displayItem name="name">Bahasa Indonesia (Indonesian)</displayItem>
+		</language>
+		<language name="it">
+			<displayItem name="name">Italiano</displayItem>
+		</language>    
+		<language name="ja">
+			<displayItem name="name">æ¥æ¬èª</displayItem>
+		</language>
+		<language name="ka">
+			<displayItem name="name">Georgian</displayItem>
+		</language>
+		<language name="kk">
+			<displayItem name="name">ÒÐ°Ð·Ð°Ò (Kazakh)</displayItem>
+		</language>
+		<language name="kn">
+			<displayItem name="name">Kannada</displayItem>
+		</language>
+		<language name="ky">
+			<displayItem name="name">ÐÑÑÐ³ÑÐ·ÑÐ° (Kirghiz)</displayItem>
+		</language>  
+  		<language name="lo">
+		  <displayItem name="name">Laotian</displayItem>
+		</language>
+
+		<language name="lv">
+			<displayItem name="name">Latvian</displayItem>
+		</language>
+		<language name="mi">
+			<displayItem name="name">MÄori</displayItem>
+		</language>
+		<language name="ml">
+			<displayItem name="name">Malayalam</displayItem>
+		</language>
+		<language name="mn">
+			<displayItem name="name">ÐÐŸÐœÐ³ÐŸÐ» (Mongolian)</displayItem>
+		</language>
+		<language name="mr">
+			<displayItem name="name">Marathi</displayItem>
+		</language>
+		<language name="my">
+		  <displayItem name="name">Burmese</displayItem>
+		</language>
+		<language name="ne">
+		  <displayItem name="name">Nepali</displayItem>
+		</language>
+
+		<language name="nl">
+		  <displayItem name="name">Nederlands (Dutch)</displayItem>
+		</language>
+		<language name="pl">
+		  <displayItem name="name">polski (Polish)</displayItem>
+		</language>
+
+		<language name="prs">
+			<displayItem name="name">Dari</displayItem>
+		</language>
+		<language name="ps">
+			<displayItem name="name">Pushto</displayItem>
+		</language>
+		<language name="pt-br">
+		  <displayItem name="name">portuguÃªs-BR (Brasil)</displayItem>
+		</language>
+		<language name="pt-pt">
+			<displayItem name="name">portuguÃªs-PT (Portugal)</displayItem>
+		</language>
+		<language name="ro">
+			<displayItem name="name">Romanian</displayItem>
+		</language>
+		<language name="ru">
+			<displayItem name="name">ÑÑÑÑÐºÐžÐ¹ (Russian)</displayItem>
+		</language>
+		<language name="si">
+			<displayItem name="name">Sinhalese</displayItem>
+		</language>
+		<language name="sk">
+		  <displayItem name="name">SlovenÄina (Slovak)</displayItem>
+		</language>
+		<language name="sr-bh-cyr">
+			<displayItem name="name">Serbian (Cyrillic - Bosnia and Herzegovina)</displayItem>
+		</language>
+		<language name="sr-bh-lat">
+			<displayItem name="name">Serbian (Latin - Bosnia and Herzegovina</displayItem>
+		</language>
+		<language name="sr-cyr">
+			<displayItem name="name">Serbian (Cyrillic)</displayItem>
+		</language>
+		<language name="sr-lat">
+			<displayItem name="name">Serbian (Latin)</displayItem>
+		</language>
+
+		<language name="ta">
+			<displayItem name="name">Tamil</displayItem>
+		</language>	
+		<language name="te">
+			<displayItem name="name">Telugu</displayItem>
+		</language>
+		<language name="th">
+			<displayItem name="name">Thai</displayItem>
+		</language>
+		<language name="ti">
+		  <displayItem name="name">Tigrinya</displayItem>
+		</language>
+
+		<language name="tr">
+			<displayItem name="name">Turkish</displayItem>
+		</language>
+		<language name="uk">
+			<displayItem name="name">Ukrainian</displayItem>
+		</language>
+		<language name="ur">
+			<displayItem name="name">Urdu</displayItem>
+		</language>
+		<language name="vi">
+			<displayItem name="name">Tiáº¿ng Viá»t</displayItem>
+		</language>
+		<language name="zh">
+			<displayItem name="name">ç®äœäž­æ (Simplified Chinese)</displayItem>
+		</language>
+		<language name="zh-tr">
+			<displayItem name="name">ç¹é«äž­æ (Traditional Chinese)</displayItem>
+		</language>
+	</languageList>
+</interfaceConfig>
Index: /gs3-installations/intermuse/trunk/interfaces/intermuse/style/core-extra.css
===================================================================
--- /gs3-installations/intermuse/trunk/interfaces/intermuse/style/core-extra.css	(revision 37057)
+++ /gs3-installations/intermuse/trunk/interfaces/intermuse/style/core-extra.css	(revision 37057)
@@ -0,0 +1,13 @@
+
+/* Override existing values */
+
+#container {
+	max-width: 1200px;
+}
+
+#topArea {
+	max-width: 1200px;
+}
+
+
+/* Add any new CSS you require for the interface here! */
Index: /gs3-installations/intermuse/trunk/interfaces/intermuse/transform/layouts/header.xsl
===================================================================
--- /gs3-installations/intermuse/trunk/interfaces/intermuse/transform/layouts/header.xsl	(revision 37057)
+++ /gs3-installations/intermuse/trunk/interfaces/intermuse/transform/layouts/header.xsl	(revision 37057)
@@ -0,0 +1,16 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<xsl:stylesheet version="1.0"
+		xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
+		xmlns:java="http://xml.apache.org/xslt/java"
+		xmlns:util="xalan://org.greenstone.gsdl3.util.XSLTUtil"
+		xmlns:gslib="http://www.greenstone.org/skinning"
+		xmlns:gsf="http://www.greenstone.org/greenstone3/schema/ConfigFormat"
+		extension-element-prefixes="java util"
+		exclude-result-prefixes="java util gsf">
+  
+  <!-- This template should be overridden in header.xsl of a new interface file if you want to add extra header content -->
+  <xsl:template name="additionalHeaderContent-interface">
+    <link rel="stylesheet" type="text/css" href="interfaces/{$interface_name}/style/core-extra.css"/>	
+  </xsl:template>
+
+</xsl:stylesheet>
Index: /gs3-installations/intermuse/trunk/interfaces/intermuse/transform/layouts/toc.xsl
===================================================================
--- /gs3-installations/intermuse/trunk/interfaces/intermuse/transform/layouts/toc.xsl	(revision 37057)
+++ /gs3-installations/intermuse/trunk/interfaces/intermuse/transform/layouts/toc.xsl	(revision 37057)
@@ -0,0 +1,48 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<xsl:stylesheet version="1.0"
+    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
+    xmlns:java="http://xml.apache.org/xslt/java"
+    xmlns:util="xalan://org.greenstone.gsdl3.util.XSLTUtil"
+    xmlns:gslib="http://www.greenstone.org/skinning"
+    xmlns:gsf="http://www.greenstone.org/greenstone3/schema/ConfigFormat"
+    extension-element-prefixes="java util"
+    exclude-result-prefixes="java util gsf">
+
+
+  <xsl:template name="rightSidebarTOC">
+    <!-- only called if gsf:option set to true, (or by default) not specified -->
+
+    <xsl:choose>
+      <xsl:when test="$bookswitch = 'mirador'">
+	
+        <div id="tocLoadingImage" style="text-align:center;">
+          <img src="{util:getInterfaceText($interface_name, /page/@lang, 'loading_image')}"/>
+          <xsl:text>Loading Mirador Viewer...</xsl:text>
+        </div>
+      </xsl:when>
+      <xsl:otherwise>
+	<!-- otherwise, go on and general the rightSidebar as usual -->
+	
+	<div id="rightSidebar">
+	  <xsl:choose>
+            <xsl:when test="@docType = 'simple'">
+              <xsl:for-each select=".">
+		<xsl:call-template name="displayCoverImage"/>
+              </xsl:for-each>
+              <xsl:call-template name="viewOptions"/>
+              <!--<xsl:text>  </xsl:text>-->
+            </xsl:when>
+            <xsl:otherwise>
+              <xsl:for-each select="documentNode[1]">
+		<xsl:call-template name="displayCoverImage"/>
+              </xsl:for-each>
+              <xsl:call-template name="viewOptions"/>
+              <xsl:call-template name="displayTOC"/>
+            </xsl:otherwise>
+	  </xsl:choose>
+	</div>
+      </xsl:otherwise>
+    </xsl:choose>
+    
+    </xsl:template>
+</xsl:stylesheet>