Index: /gs3-installations/intermuse/trunk/sites/intermuse/collect/programmes/transform/pages/document-iiif-manifest.xsl
===================================================================
--- /gs3-installations/intermuse/trunk/sites/intermuse/collect/programmes/transform/pages/document-iiif-manifest.xsl	(revision 37086)
+++ /gs3-installations/intermuse/trunk/sites/intermuse/collect/programmes/transform/pages/document-iiif-manifest.xsl	(revision 37087)
@@ -58,4 +58,6 @@
   </xsl:template>
   
+
+  <!-- **** improve name !!!! -->
   
   <xsl:template name="iiif-links">
@@ -70,5 +72,5 @@
     <!-- page/pageRequest[@fullURL]="//intermuse.sowemustthink.space/greenstone3/library?a=d.... -->
 
-    <!-- ***** need to work out from raw XML message, say processing something from the above -->
+    <!-- ***** need to work out domain name to use from raw XML message, say processing something from the above -->
     
     <xsl:variable name="document-location-origin">https://intermuse.sowemustthink.space</xsl:variable>
@@ -156,5 +158,4 @@
   <xsl:template name="wrappedSectionPost">
 
-    <!-- **** improve name !!!! -->
     <!-- add in IIIF Server link for section image -->
     <xsl:variable name="nodeID" select="@nodeID"/>
@@ -226,7 +227,4 @@
     <xsl:call-template name="documentContentSimpleIIIFImage"/>
     <xsl:call-template name="documentPost"/>
-    <!--
-    <xsl:call-template name="documentPostMirador3OLD"/>
-    -->
   </xsl:template>
 
@@ -243,13 +241,4 @@
   
 
-  <xsl:template name="documentPostMirador3OLD">
-
-    <!-- Container element of Mirador whose id should be passed to the instantiating call as "id" -->    
-    <div style="position: relative; width: 100%; height: 800px;">
-      <div id="mirador3-viewer"> <xsl:comment>filler</xsl:comment></div>
-    </div>
-    
-  </xsl:template>
-
   <xsl:template name="wrappedDocumentTopLevel">
 
@@ -262,49 +251,4 @@
 
   </xsl:template>
-
-
-  <!-- **** see about eliminating the following => shouldn't be needed! !!!! -->
-	<!-- content of a simple document. Will not be used for editing mode -->
-	<xsl:template name="documentPostInProgressOLD">
-
-
-			    <gsf:script src="https://unpkg.com/mirador@latest/dist/mirador.min.js"/>
-
-
-			    <!-- By default uses Roboto font. Be sure to load this or change the font -->
-			    <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Roboto:300,400,500" />
-			    <!-- Container element of Mirador whose id should be passed to the instantiating call as "id" -->
-			    
-			    <div style="position: relative; width: 100%; height: 800px;">
-			      <div id="my-mirador"> <xsl:comment>filler</xsl:comment></div>
-			    </div>
-			    
-			    <gsf:script>
-			      
-var mirador = Mirador.viewer({
-  "id": "my-mirador",
-  "manifests": {
-    "https://intermuse.sowemustthink.space/greenstone3/sample-manifest.json": {
-      "provider": "IntermusE"
-    }
-    },
-  "window" : { "panels" : { "annotations": true, "attribution": false } },
-  "annotations": {
-    "htmlSanitizationRuleSet": 'iiif', // See src/lib/htmlRules.js for acceptable values
-    "filteredMotivations": ['oa:commenting', 'oa:tagging', 'sc:painting', 'commenting', 'tagging'],
-  },    
-  "windows": [
-    {
-      "loadedManifest": "https://intermuse.sowemustthink.space/greenstone3/sample-manifest.json",
-      "canvasIndex": 1,
-      "thumbnailNavigationPosition": 'far-bottom'
-    }
-  ]
-});
-			    </gsf:script>
-
-	  
-	</xsl:template>
-	
 
 
@@ -331,28 +275,4 @@
 	<xsl:template name="wrappedSectionImage">
 	  <!-- don't need this template to generate anything in the IIIF-Manifest JSON case -->
-	</xsl:template>
-	
-	<xsl:template name="wrappedSectionImageOLD">
-		<xsl:variable name="screenImageWidth"><gsf:metadata name="ScreenWidth"/></xsl:variable>
-		<xsl:variable name="screenImageHeight"><gsf:metadata name="ScreenHeight"/></xsl:variable>
-		<xsl:variable name="imageWidth"><gsf:metadata name="ImageWidth"/></xsl:variable>
-		<xsl:variable name="imageHeight"><gsf:metadata name="ImageHeight"/></xsl:variable>
-		<xsl:variable name="docNodeID"><xsl:value-of select="@nodeID"/></xsl:variable> <!-- used to make each 'tidyDiv' unique -->
-
-				<gsf:div id="image{@nodeID}">
-					<xsl:attribute name="style">
-						<xsl:choose>
-							<xsl:when test="/page/pageRequest/paramList/param[@name = 'view']/@value = 'text'">
-								<xsl:text>display:none;</xsl:text>
-							</xsl:when>
-							<xsl:otherwise>
-								<xsl:text>display:block;</xsl:text>
-							</xsl:otherwise>
-						</xsl:choose>
-					</xsl:attribute>
-					<xsl:call-template name="sectionImage"/><xsl:text> </xsl:text>
-				</gsf:div>
-
-
 	</xsl:template>
 	