Index: in/trunk/greenstone3/web/interfaces/default/transform/pages/document-core.xsl
===================================================================
--- /main/trunk/greenstone3/web/interfaces/default/transform/pages/document-core.xsl	(revision 37090)
+++ 	(revision )
@@ -1,68 +1,0 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<xsl:stylesheet version="1.0"
-	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
-	xmlns:java="http://xml.apache.org/xslt/java"
-	xmlns:util="xalan://org.greenstone.gsdl3.util.XSLTUtil"
-	xmlns:gslib="http://www.greenstone.org/skinning"
-	xmlns:gsf="http://www.greenstone.org/greenstone3/schema/ConfigFormat"
-	extension-element-prefixes="java util"
-	exclude-result-prefixes="java util gsf">
-
-	<xsl:variable name="docID" select="/page/pageRequest/paramList/param[@name='d']/@value"/>
-
-        <xsl:template name="documentHeading">
-	  <span style="font-weight:bold; font-size: 120%;">
-	    <xsl:call-template name="choose-title"/>
-	  </span>
-	</xsl:template>
-
-	<!-- content of a simple document. Will not be used for editing mode -->
-	<xsl:template name="documentContent">
-	  <div id="gs-document">
-	    <xsl:call-template name="documentPre"/>
-	    <xsl:call-template name="wrappedSectionImage"/>
-	    <div id="gs-document-text">
-	      <xsl:call-template name="documentNodeText"/>
-	    </div>
-	    <xsl:call-template name="documentPost"/>
-	  </div>
-	</xsl:template>
-
-	<!-- For symmetry reasons, companion template to wrappedDocumentTopLevel -->
-	<xsl:template name="documentContentTopLevel">
-	  <xsl:call-template name="documentContent"/>
-	</xsl:template>
-	
-	<xsl:template name="topLevelSectionContent">
-		<xsl:call-template name="wrappedSectionImage"/>
-		<xsl:call-template name="wrappedSectionText"/>
-	</xsl:template>
-	
-	<xsl:template name="sectionContent">
-		<xsl:call-template name="wrappedSectionImage"/>
-		<xsl:call-template name="wrappedSectionText"/>
-	</xsl:template>
-
-	<xsl:template name="wrappedSectionText">
-	  <!-- <br /><br /> --> <!-- **** better to do with CSS .setionText -->
-	  
-		<div id="text{@nodeID}" class="sectionText"><!-- *** -->
-			<xsl:attribute name="style">
-				<xsl:choose>
-					<xsl:when test="/page/pageRequest/paramList/param[@name = 'view']/@value = 'image'">
-						<xsl:text>display:none;</xsl:text>
-					</xsl:when>
-					<xsl:otherwise>
-						<xsl:text>display:block;</xsl:text>
-					</xsl:otherwise>
-				</xsl:choose>
-			</xsl:attribute>
-			<xsl:call-template name="documentNodeText"/>
-		</div>
-	</xsl:template>
-	
-	<xsl:template name="sectionImage">
-		<gsf:image type="screen"/>
-	</xsl:template>
-	
-</xsl:stylesheet>
Index: /main/trunk/greenstone3/web/interfaces/default/transform/pages/document-vars.xsl
===================================================================
--- /main/trunk/greenstone3/web/interfaces/default/transform/pages/document-vars.xsl	(revision 37091)
+++ /main/trunk/greenstone3/web/interfaces/default/transform/pages/document-vars.xsl	(revision 37091)
@@ -0,0 +1,13 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<xsl:stylesheet version="1.0"
+	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
+	xmlns:java="http://xml.apache.org/xslt/java"
+	xmlns:util="xalan://org.greenstone.gsdl3.util.XSLTUtil"
+	xmlns:gslib="http://www.greenstone.org/skinning"
+	xmlns:gsf="http://www.greenstone.org/greenstone3/schema/ConfigFormat"
+	extension-element-prefixes="java util"
+	exclude-result-prefixes="java util gsf">
+
+	<xsl:variable name="docID" select="/page/pageRequest/paramList/param[@name='d']/@value"/>
+	
+</xsl:stylesheet>
Index: /main/trunk/greenstone3/web/interfaces/default/transform/pages/document.xsl
===================================================================
--- /main/trunk/greenstone3/web/interfaces/default/transform/pages/document.xsl	(revision 37090)
+++ /main/trunk/greenstone3/web/interfaces/default/transform/pages/document.xsl	(revision 37091)
@@ -19,5 +19,5 @@
 	<!-- <xsl:include href="document-shared.xsl" /> -->
 
-	<xsl:include href="pages/document-core.xsl" />
+	<xsl:include href="pages/document-vars.xsl" />
 	
 
@@ -90,8 +90,58 @@
 	</xsl:template>
 
-	<!-- **** Rules for document-core.xsl taken from here --> 
+        <xsl:template name="documentHeading">
+	  <span style="font-weight:bold; font-size: 120%;">
+	    <xsl:call-template name="choose-title"/>
+	  </span>
+	</xsl:template>
+
+	<!-- content of a simple document. Will not be used for editing mode -->
+	<xsl:template name="documentContent">
+	  <div id="gs-document">
+	    <xsl:call-template name="documentPre"/>
+	    <xsl:call-template name="wrappedSectionImage"/>
+	    <div id="gs-document-text">
+	      <xsl:call-template name="documentNodeText"/>
+	    </div>
+	    <xsl:call-template name="documentPost"/>
+	  </div>
+	</xsl:template>
+
+	<!-- For symmetry reasons, companion template to wrappedDocumentTopLevel -->
+	<xsl:template name="documentContentTopLevel">
+	  <xsl:call-template name="documentContent"/>
+	</xsl:template>
+	
+	<xsl:template name="topLevelSectionContent">
+		<xsl:call-template name="wrappedSectionImage"/>
+		<xsl:call-template name="wrappedSectionText"/>
+	</xsl:template>
+	
+	<xsl:template name="sectionContent">
+		<xsl:call-template name="wrappedSectionImage"/>
+		<xsl:call-template name="wrappedSectionText"/>
+	</xsl:template>
+		
 	<xsl:template name="sectionContentForEditing">
 		<xsl:call-template name="wrappedSectionImage"/>
 		<xsl:call-template name="wrappedSectionTextForEditing"/>
+	</xsl:template>
+	
+	<xsl:template name="wrappedSectionText">
+	  <!-- <br /><br /> --> <!-- **** better to do with CSS .setionText -->
+	  
+		<div id="text{@nodeID}" class="sectionText"><!-- *** -->
+			<xsl:attribute name="style">
+				<xsl:choose>
+					<xsl:when test="/page/pageRequest/paramList/param[@name = 'view']/@value = 'image'">
+						<xsl:text>display:none;</xsl:text>
+					</xsl:when>
+					<xsl:otherwise>
+						<xsl:text>display:block;</xsl:text>
+					</xsl:otherwise>
+				</xsl:choose>
+			</xsl:attribute>
+			<xsl:call-template name="documentNodeText"/>
+		</div>
 	</xsl:template>
 
@@ -105,4 +155,9 @@
 		</div>
 	</xsl:template>
+	
+	<xsl:template name="sectionImage">
+		<gsf:image type="screen"/>
+	</xsl:template>
+
 
 	<!-- Used to make sure that regardless what the collection designer uses for the title and content we can wrap it properly -->